package com.teamdev.jxbrowser.chromium.internal;

import com.teamdev.jxbrowser.chromium.Cookie;
import java.util.concurrent.TimeUnit;

public class CookieImpl implements Cookie {

   private static long a = 11644473600L;
   private final String b;
   private final String c;
   private final String d;
   private final String e;
   private final long f;
   private final long g;
   private final boolean h;
   private final boolean i;
   private final boolean j;


   private CookieImpl(String name, String value, String domain, String path, long creationTime, long expirationTime, boolean secure, boolean httpOnly) {
      this.b = name;
      this.c = value;
      this.d = domain;
      this.e = path;
      this.f = creationTime;
      this.g = expirationTime;
      this.h = secure;
      this.i = httpOnly;
      this.j = expirationTime == 0L;
   }

   public static Cookie create(String name, String value, String domain, String path, long creationTimeInMicroseconds, long expirationTimeInMicroseconds, boolean secure, boolean httpOnly) {
      if(name == null) {
         throw new IllegalArgumentException("The name parameter cannot be null.");
      } else if(value == null) {
         throw new IllegalArgumentException("The value parameter cannot be null.");
      } else if(path != null && !path.isEmpty()) {
         if(creationTimeInMicroseconds < 0L) {
            throw new IllegalArgumentException("The creationTimeInMicroseconds parameter cannot be negative.");
         } else if(expirationTimeInMicroseconds < 0L) {
            throw new IllegalArgumentException("The expirationTimeInMicroseconds parameter cannot be negative.");
         } else {
            return new CookieImpl(name, value, domain, path, creationTimeInMicroseconds, expirationTimeInMicroseconds, secure, httpOnly);
         }
      } else {
         throw new IllegalArgumentException("The path parameter cannot be null or empty string.");
      }
   }

   public String getName() {
      return this.b;
   }

   public String getValue() {
      return this.c;
   }

   public String getDomain() {
      return this.d;
   }

   public String getPath() {
      return this.e;
   }

   public long getCreationTime() {
      return this.f;
   }

   public long getUnixCreationTime() {
      return TimeUnit.MICROSECONDS.toSeconds(this.f) - a;
   }

   public long getExpirationTime() {
      return this.g;
   }

   public long getUnixExpirationTime() {
      return TimeUnit.MICROSECONDS.toSeconds(this.g) - a;
   }

   public boolean isSecure() {
      return this.h;
   }

   public boolean isHTTPOnly() {
      return this.i;
   }

   public boolean isSession() {
      return this.j;
   }

   public String toString() {
      return "CookieImpl{name=\'" + this.b + '\'' + ", value=\'" + this.c + '\'' + ", domain=\'" + this.d + '\'' + ", path=\'" + this.e + '\'' + ", creationTime=" + this.f + ", expirationTime=" + this.g + ", secure=" + this.h + ", httpOnly=" + this.i + ", session=" + this.j + '}';
   }

}
